JavaScript Charts | Get Started with ag-Charts

ag-Charts is an exciting new addition to the ag-Grid family, offering both integrated as well as standalone fully functional charting capabilities.

Quick Look Code Example
var data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700 }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520 }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200 } ]; var options = { container: document.querySelector('#myChart'), data: data, title: { text: 'Beverage Expenses' }, subtitle: { text: 'per quarter' }, padding: { top: 40, right: 40, bottom: 40, left: 40 }, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] }], legend: { spacing: 40 } }; agCharts.AgChart.create(options);
<!DOCTYPE html> <html lang="en"> <head> <title>ag-Charts Basic Example</title> <script src="https://unpkg.com/ag-charts-community/dist/ag-charts-community.min.js"> </script> </head> <body> <div id="myChart" style="height: 100%; width:500px;"></div> <script src="main.js"></script> </body> </html>

Getting Started

In this article we will walk through the necessary steps to add ag-Charts to an existing JavaScript project and produce your first charts.

Your First Chart

Let's say you want to visualise how much you spend on coffee each quarter and that you have the following data:

var data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700 }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520 }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200 } ];

To render it we can use this simple chart factory configuration:

AgChart.create({ data: data, container: document.querySelector('#myChart'), series: [{ xKey: 'quarter', yKey: 'spending' }] });

Here we pass in the data we want to render, the container element for the chart (our chart won't be attached to the DOM without it) and the series to use to plot the data.

The series type defaults to 'line' so the only series configuration we need to specify is which keys to use to fetch the data to be plotted along the horizontal (x) and vertical (y) axes.

The series property is an array because it is possible to supply multiple series (including mixed kinds!) into a single chart.

The default axes configuration is a category axis on the bottom and number axis on the left of a chart, both of which are exactly what we need in this case, so we don't need to supply these here.

The chart also features a legend by default which uses the yKey for the series, which in this case is 'spending'.

Line Chart

Customising the Legend

If we don't want the legend to show the yKey itself we can give it a name, for example 'Coffee Spending'.

This name is more descriptive but also longer, so let's position the legend on the bottom of the chart to make more space for the series:

AgChart.create({ data: data, container: document.querySelector('#myChart'), series: [{ xKey: 'quarter', yKey: 'spending', + yName: 'Coffee Spending' }], + legend: { + position: 'bottom' + } });
Line Chart

Basic Column Chart

Now let's try something more interesting. Let's say you want to visualise how much is spent on coffee, milk and tea in your company each quarter and in total. Your data might look something like this:

var data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700 }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520 }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200 }, ];

This time, let's choose another series type to plot the data: stacked columns. Here's the chart factory configuration we can use to do that:

AgChart.create({ data: data, container: document.querySelector('#myChart'), series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] }] });

Unlike 'line' series charts, 'column' series can have multiple yKeys which allow for stacking, in our case one block per quarter.

Chart tooltips are enabled by default so you can hover over a block to see its value.

Column Chart

Labels and Titles

We can enhance our chart by providing a label for each block segment. We can set a label's fontSize, fontFamily and other properties, but for now we'll just accept the default values:

AgChart.create({ data: data, container: document.querySelector('#myChart'), series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'], + label: {} }] });
Column Chart

If we then want to add a title and subtitle to the chart, we can simply add this to our chart config:

AgChart.create({ data: data, container: document.querySelector('#myChart'), + title: { + text: 'Beverage Expenses' + }, + subtitle: { + text: 'per quarter' + }, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'], label: {} }] });
Column Chart

Now that you've had a taste of what it's like to use ag-Charts, we encourage you to explore our documentation to learn more.

Next Up

Continue to the next section to see the API Reference.

React Charts | Get Started with ag-Charts and React

ag-Charts is an exciting new addition to the ag-Charts family, offering both integrated as well as standalone fully functional charting capabilities.

Quick Look Code Example
import React, { Component } from 'react'; import { render } from 'react-dom'; import { AgChartsReact } from 'ag-charts-react'; class ChartExample extends Component { data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700, }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520, }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200, }, ]; constructor(props) { super(props); this.state = { options: { data: this.data, title: { text: 'Beverage Expenses' }, subtitle: { text: 'per quarter' }, padding: { top: 40, right: 40, bottom: 40, left: 40, }, series: [ { type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'], }, ], legend: { spacing: 40 }, }, }; } render() { return <AgChartsReact options={this.state.options} />; } } render(<ChartExample />, document.querySelector('#root'));
<div id="root"></div>

Getting Started

In this article we will walk you through the necessary steps to add ag-Charts to an existing React project and produce your first charts.

Add ag-Charts to Your Project

For the purposes of this tutorial, we are going to scaffold a React app with create-react-app.

Don't worry if your project has a different configuration - ag-Charts and the React wrapper are distributed as NPM packages, which should work with any common React project module bundler setup.

Let's follow the create-react-app instructions and run the following commands in your terminal:

npx create-react-app my-app cd my-app npm start
npx comes with npm 5.2+ and higher, for older npm versions use these instructions

If everything goes well, npm start has started the web server and conveniently opened a browser pointing to localhost:3000.

As a next step, let's add the ag-Charts NPM packages. Run the following command in my-app (you may need a new instance of the terminal):

npm install --save ag-charts-community ag-charts-react

After a few seconds of waiting, you should be good to go. Let's get to the actual coding! Open src/App.js in your favourite text editor and change its contents to the following:

import React, { Component } from 'react'; import { render } from 'react-dom'; import { AgChartsReact } from 'ag-charts-react'; class ChartExample extends Component { data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700, }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520, }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200, }, ]; constructor(props) { super(props); this.state = { options: { data: data, series: [{ xKey: 'quarter', yKey: 'spending' }] }, }; } render() { return <AgChartsReact options={this.state.options} />; } }

Here we'll provide the options we want to use for our chart, including the series to use to plot the data.

The series type defaults to 'line' so the only series configuration we need to specify is to tell the series which keys to use to fetch the data to be plotted along the horizontal (x) and vertical (y) axes.

The series property is an array because it is possible to supply multiple series (including mixed kinds!) into a single chart.

The default axes configuration is a category axis on the bottom and number axis on the left of a chart, both of which are exactly what we need, so we don't need to supply these here.

The chart also features a legend by default which shows the yKey the series is using, in our case 'spending'.

With all this in place we should now see:

Line Chart

Customising the Legend

If we don't want the legend to show the value of the yKey itself we can give it a name, for example 'Coffee Spending'.

This name is more descriptive but also longer, so let's position the legend on the bottom of the chart to make more space for the series:

constructor(props) { super(props); this.state = { options: { data: data, series: [{ xKey: 'quarter', yKey: 'spending' + yName: 'Coffee Spending' }], + legend: { + position: 'bottom' + } }; } }
Line Chart

Basic Column Chart

Now let's try something more interesting. Let us say you want to visualize how much is spent on coffee, milk and tea in your company each quarter and in total. Your data might look something like this:

data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700 }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520 }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200 }, ];

This time, let's choose another series type to plot the data: stacked columns. Here's the chart configuration we can use to do that:

constructor(props) { super(props); this.state = { options: { data: this.data, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] }] } }

Unlike 'line' series charts, 'column' series can have multiple yKeys which allow for stacking, in our case one block per quarter.

Chart tooltips are enabled by default so you can hover over a block to see its value.

Column Chart

Labels and Titles

We can enhance our chart by providing a label for each block segment. We can set a label's fontSize, fontFamily and other properties, but for now we'll just accept the default values:

constructor(props) { super(props); this.state = { options: { data: this.data, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] + label: {} }] } }
Column Chart

If we then want to add a title and subtitle to the chart, we can simply add this to our chart config:

constructor(props) { super(props); this.state = { options: { data: this.data, + title: { + text: 'Beverage Expenses' + }, + subtitle: { + text: 'per quarter' + }, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] label: {} }] } }
Column Chart

Now that you've had a taste of what it's like to use ag-Charts, we encourage you to explore our documentation to learn more.

Next Up

Continue to the next section to see the API Reference.

Angular Charts | Get Started with ag-Charts and Angular

ag-Charts is an exciting new addition to the ag-Charts family, offering both integrated as well as standalone fully functional charting capabilities.

Quick Look Code Example
import { BrowserModule } from '@angular/platform-browser'; import { NgModule } from '@angular/core'; import { AgChartsAngularModule } from 'ag-charts-angular'; import { AppComponent } from './app.component'; @NgModule({ imports: [ BrowserModule, AgChartsAngularModule ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { }
<ag-charts-angular style="height: 100%" [options]="options"> </ag-charts-angular>

Getting Started

In this article we will walk you through the necessary steps to add ag-Charts to an existing Angular project and produce your first charts.

Add ag-Charts to Your Project

For the purposes of this tutorial, we are going to scaffold an Angular app with the Angular CLI.

Don't worry if your project has a different configuration - ag-Charts and its Angular wrapper are distributed as NPM packages and work with all common Angular project setups.

Let's follow the Angular CLI instructions and run the following in your terminal:

npm install -g @angular/cli ng new my-app --routing false cd my-app ng serve

If everything goes well, ng serve has started the web server. You can open your app at localhost:4200.

As a next step, let's add the ag-Charts NPM packages. Run the following command in my-app (you may need a new instance of the terminal):

npm install --save ag-charts-community ag-charts-angular npm install # in certain circumstances npm will perform an "auto prune". This step ensures all expected dependencies are present

After a few seconds of waiting, you should be good to go. Let's get to the actual coding! As a first step, let's add the ag-Charts Angular module to our app module (src/app/app.module.ts):

import { BrowserModule } from '@angular/platform-browser'; import { NgModule } from '@angular/core'; import { AgChartsAngularModule } from 'ag-charts-angular'; import { AppComponent } from './app.component'; @NgModule({ imports: [ BrowserModule, AgChartsAngularModule ], declarations: [AppComponent], bootstrap: [AppComponent], }) export class AppModule { }

Next, let's declare the basic chart configuration. Edit src/app.component.ts:

import { Component } from '@angular/core'; import { AgChartOptions } from 'ag-charts-angular'; @Component({ selector: 'my-app', templateUrl: './app.component.html' }) export class AppComponent { private options: AgChartOptions; data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700, }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520, }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200, }, ]; constructor() { this.options = { data: this.data, series: [{ xKey: 'quarter', yKey: 'spending' }] }; } }

Here we'll provide the options we want to use for our chart, including the series to use to plot the data.

The series type defaults to 'line', so the only series configuration we need to specify is to tell the series which keys to use to fetch the data to be plotted along the horizontal (x) and vertical (y) axes.

Finally, let's add the component definition to our template. Edit app/app.component.html and remove the scaffold code:

<ag-charts-angular style="height: 100%" [options]="options"> </ag-charts-angular>

The series property is an array because it is possible to supply multiple series (including mixed kinds!) into a single chart.

The default axes configuration is a category axis on the bottom and number axis on the left of a chart, both of which are exactly what we need, so we don't need to supply these here.

The chart also features a legend by default which shows the yKey the series is using, in our case 'spending'.

Line Chart

Customising the Legend

If we don't want the legend to show the value of the yKey itself we can give it a name, for example 'Coffee Spending'.

This name is more descriptive but also longer, so let's position the legend on the bottom of the chart to make more space for the series:

constructor() { this.options = { data: this.data, series: [{ xKey: 'quarter', yKey: 'spending' + yName: 'Coffee Spending' }], + legend: { + position: 'bottom' + } }; });
Line Chart

Basic Column Chart

Now let's try something more interesting. Let us say you want to visualize how much is spent on coffee, milk and tea in your company each quarter and in total. Your data might look something like this:

data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700 }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520 }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200 }, ];

This time, let's choose another series type to plot the data: stacked columns. Here's the chart configuration we can use to do that:

constructor() { this.options = { data: this.data, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] }] }; });

Unlike 'line' series charts, 'column' series can have multiple yKeys which allow for stacking, in our case one block per quarter.

Chart tooltips are enabled by default so you can hover over a block to see its value.

Column Chart

Labels and Titles

We can enhance our chart by providing a label for each block segment. We can set a label's fontSize, fontFamily and other properties, but for now we'll just accept the default values:

constructor() { this.options = { data: this.data, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'], + label: {} }] }; });
Column Chart

If we then want to add a title and subtitle to the chart, we can simply add this to our chart config:

constructor() { this.options = { data: this.data, + title: { + text: 'Beverage Expenses' + }, + subtitle: { + text: 'per quarter' + }, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'], label: {} }] }; });
Column Chart

Now that you've had a taste of what it's like to use ag-Charts, we encourage you to explore our documentation to learn more.

Next Up

Continue to the next section to see the API Reference.

Vue Charts | Get Started with ag-Charts and Vue

ag-Charts is an exciting new addition to the ag-Charts family, offering both integrated as well as standalone fully functional charting capabilities.

Quick Look Code Example
import Vue from 'vue'; import { AgChartsVue } from 'ag-charts-vue'; const ChartExample = { template: `<ag-charts-vue :options="options"></ag-charts-vue>`, components: { 'ag-charts-vue': AgChartsVue, }, data: function() { return { options: null, data: [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700, }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520, }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200, }, ] }; }, beforeMount() { this.options = { data: this.data, title: { text: 'Beverage Expenses' }, subtitle: { text: 'per quarter' }, padding: { top: 40, right: 40, bottom: 40, left: 40, }, series: [ { type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'], }, ], legend: { spacing: 40 }, }; } };
import Vue from 'vue'; import { App } from './app'; new Vue({ el: '#root', render: h => h(App) });

Getting Started

In this article we will walk you through the necessary steps to add ag-Charts to an existing Vue project and produce your first charts.

Add ag-Charts to Your Project

For the purposes of this tutorial, we are going to scaffold an Vue app with the Vue CLI.

Don't worry if your project has a different configuration. ag-Charts and its Vue wrapper are distributed as NPM packages and work with any common Vue project setup.

Let's follow the Vue CLI instructions and run the following in your terminal:

npm install -g @vue/cli vue create my-project

When prompted choose "default (babel, eslint)":

Select Default Features

We're now ready to start our application:

cd my-project npm run serve

If everything goes well, npm run serve has started the web server. You can open the default app at localhost:8080.

Let's add the ag-Charts NPM packages. Run the following command in my-project (you may need a new instance of the terminal):

npm install --save ag-charts-community ag-charts-vue

After a few seconds of waiting, you should be good to go. Let's get to the actual coding! As a first step, let's add the ag-Charts module. As this will be a simple example we can delete the src/components directory. Our example application will live in src/App.vue.

Let's add the component definition to our template. Edit app/App.vue and replace the scaffold code:

<template> <ag-charts-vue :options="options"></ag-charts-vue> </template>

Next, let's declare the basic charts configuration. Edit src/App.vue:

<script> import Vue from 'vue'; import { AgChartsVue } from 'ag-charts-vue'; export default { name: 'App', components: { AgChartsVue, }, data() { return { options: null, data: [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700, }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520, }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200, }, ] }; }, beforeMount() { this.options = { data: this.data, series: [{ xKey: 'quarter', yKey: 'spending' }] }; } }; </script>

Here we'll provide the options we want to use for our chart, including the series to use to plot the data.

The series type defaults to 'line' so the only series configuration we need to specify is to tell the series which keys to use to fetch the data to be plotted along the horizontal (x) and vertical (y) axes.

The series property is an array because it is possible to supply multiple series (including mixed kinds!) into a single chart.

The default axes configuration is a category axis on the bottom and number axis on the left of a chart, both of which are exactly what we need, so we don't need to supply these here.

The chart also features a legend by default which shows the yKey the series is using, in our case 'spending'.

Line Chart

Customising the Legend

If we don't want the legend to show the value of the yKey itself we can give it a name, for example 'Coffee Spending'.

This name is more descriptive but also longer, so let's position the legend on the bottom of the chart to make more space for the series:

beforeMount() { this.options = { data: this.data, series: [{ xKey: 'quarter', yKey: 'spending' + yName: 'Coffee Spending' }], + legend: { + position: 'bottom' + } }; }
Line Chart

Basic Column Chart

Now let's try something more interesting. Let us say you want to visualise how much is spent on coffee, milk and tea in your company each quarter and in total. Your data might look something like this:

data = [ { beverage: 'Coffee', Q1: 450, Q2: 560, Q3: 600, Q4: 700 }, { beverage: 'Tea', Q1: 270, Q2: 380, Q3: 450, Q4: 520 }, { beverage: 'Milk', Q1: 180, Q2: 170, Q3: 190, Q4: 200 }, ];

This time, let's choose another series type to plot the data: stacked columns. Here's the chart configuration we can use to do that:

beforeMount() { this.options = { data: this.data, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] }] }; }

Unlike 'line' series charts, 'column' series can have multiple yKeys which allow for stacking - in our case one block per quarter.

Chart tooltips are enabled by default so you can hover a block to see its value.

Column Chart

Labels and Titles

We can enhance our chart by providing a label for each block segment. We can set a label's fontSize, fontFamily and other properties, but for now we'll just accept the default values:

beforeMount() { this.options = { data: this.data, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] + label: {} }] }; }
Column Chart

If we then want to add a title and subtitle to the chart, we can simply add this to our chart config:

beforeMount() { this.options = { data: this.data, + title: { + text: 'Beverage Expenses' + }, + subtitle: { + text: 'per quarter' + }, series: [{ type: 'column', xKey: 'beverage', yKeys: ['Q1', 'Q2', 'Q3', 'Q4'] label: {} }] }; }
Column Chart

Now that you've had a taste of what it's like to use ag-Charts, we encourage you to explore our documentation to learn more.

Next Up

Continue to the next section to see the API Reference.